/* -*- c++ -*- */
/*
 * Copyright 2017 <+YOU OR YOUR COMPANY+>.
 *
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street,
 * Boston, MA 02110-1301, USA.
 */


#ifndef INCLUDED_BLOCKSAT_FRAME_SYNC_FAST_H
#define INCLUDED_BLOCKSAT_FRAME_SYNC_FAST_H

#include <blocksat/api.h>
#include <gnuradio/block.h>

namespace gr {
  namespace blocksat {

    /*!
     * \brief <+description of block+>
     * \ingroup blocksat
     *
     */
    class BLOCKSAT_API frame_sync_fast : virtual public gr::block
    {
     public:
      typedef boost::shared_ptr<frame_sync_fast> sptr;

      /*!
       * \brief Return a shared_ptr to a new instance of blocksat::frame_sync_fast.
       *
       * To avoid accidental use of raw pointers, blocksat::frame_sync_fast's
       * constructor is in a private implementation
       * class. blocksat::frame_sync_fast::make is the public interface for
       * creating new instances.
       */
      static sptr make(float treshold, int preamble_len, int payload_len, int n_init_peak, int equalize, int fix_phase, int const_order, int verbosity);

      /*
       * Getters for public metrics
       */
      virtual float get_avg_timing_metric() = 0;
      virtual float get_timing_rec_indicator() = 0;
      virtual int get_state() = 0;
    };
  } // namespace blocksat
} // namespace gr

#endif /* INCLUDED_BLOCKSAT_FRAME_SYNC_FAST_H */
